﻿Imports System
Imports System.Collections.Generic
Imports System.Text
Imports System.Threading
Imports HBDotNet

Namespace TestLibrary
    <HBDevice("Clock")> _
    <HBProperty("Current Time", ePropertyType.ptTime, "")> _
    <HBProperty("Tick Every 5 Seconds", ePropertyType.ptBoolean, "No")> _
    Public Class Class1
        Inherits HBDeviceBase
        Private _thread As Thread

        Public Overloads Overrides Function OnInit(ByVal enabled As Boolean) As Boolean
            If enabled Then
                OnEnable()
            End If
            Return MyBase.OnInit(enabled)
        End Function

        Public Overloads Overrides Sub OnShutdown()
            If _thread IsNot Nothing Then
                _thread.Abort()
            End If
            MyBase.OnShutdown()
        End Sub

        Public Overloads Overrides Function OnEnable() As Boolean
            Dim operation As New ThreadStart(AddressOf ThreadFunc)

            _thread = New Thread(operation)
            _thread.Start()
            Return MyBase.OnEnable()
        End Function

        Public Overloads Overrides Function OnDisable() As Boolean
            If _thread IsNot Nothing Then
                _thread.Abort()
            End If
            _thread = Nothing
            Return MyBase.OnDisable()
        End Function

        Public Sub ThreadFunc()
            While True
                Thread.Sleep(1000)
                Dim D As DateTime = DateTime.Now
                Properties(0).CurrentValue = D.ToString()
                If (D.Second Mod 5) = 0 Then
                    If Properties(1).CurrentValue = "Yes" Then
                        System.Diagnostics.Debug.WriteLine("BEEP")
                    End If
                End If
            End While
        End Sub
    End Class
End Namespace